#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf nbd.14.tar.gz
    cd nbd
    bunzip2 -c ../nbd-1.4-dietpc-patch.bz2 | patch -p1 -b
    ./configure --prefix=/usr --sysconfdir=/etc
    make nbd-server CFLAGS="$CFLAGS -DLIBWRAP" LIBS=-lwrap
    strip -R .note -R .comment nbd-server
    mkdir -p ../nbd-server/sbin
    cp nbd-server ../nbd-server/sbin/
    cd ..
    rm -rf nbd
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
